int face_distance()
// distance to target, positive when faced towards it
// 80 pixels may be considered as a maximum distance allowing close combat
{
    return ( self.x - target.x ) * ( 2 * ( self.facing ? 1 : 0 ) - 1 );
}

bool dist_between( int min, int max )
// checks whether distance to target is within bounds
{
    return ( ( face_distance() < max ) && ( face_distance() > min ) );
}

bool z_axis_dist( int dist )
{
    return ( abs( self.z - target.z ) <= dist ) ? true : false;
}

bool same_z_axis()
// checks whether our character is on the same z axis as the opponent
{
    return ( abs( self.z - target.z ) <= 8 ) ? true : false;
}

int ego()
{
    if( ( self.frame >= 261 ) && ( self.frame <= 269 ) )
    {
        if( ( target.state == 13 ) || ( target.state == 14 ) )
        {
            D();
            return 0;
        }
        if( ( self.frame == 269 ) && ( target.y == 0 ) )
        {
            D();
            return 0;
        }
        return 1;
    }
    else
    {



        if( dist_between(1,25) && same_z_axis() && ( self.mp > 60 ) && ( target.state < 10 ) )
        {
            DuJ();
            return 0;
        }

        if( dist_between(155,180) && same_z_axis() && ( self.mp > 90 ) && ( target.state < 10 ) )
        {
            DuA();
            return 0;
        }


        if( dist_between(40,100) && same_z_axis() && ( self.mp > 65 ) && ( target.state < 10 )  )
        {
            DdA();
            return 0;
        }



        if( dist_between(100,154) && same_z_axis() && ( self.mp > 105 ) && ( difficulty < 1) && ( target.state < 10 )  )
        {
            DdJ();
            return 0;
        }


        if( dist_between(160,220) && same_z_axis() && ( self.mp > 90 ) && ( target.state < 10 )  )
        {
            if( self.facing )
            {
                DlA();
                A();
            }
            else
            {
                DrA();
                A();
            }
            return 0;
        }



        if( dist_between(170,400) && same_z_axis() && ( self.mp > 150 ) && ( difficulty < 2) && ( target.state < 10 )   )
        {
            if( self.facing )
            {
                DlJ();
                A();
            }
            else
            {
                DrJ();
                A();
            }
            return 0;
        }




       

    }
    return 0;
}