int face_distance()
// distance to target, positive when faced towards it
// 80 pixels may be considered as a maximum distance allowing close combat
{
    return ( self.x - target.x ) * ( 2 * ( self.facing ? 1 : 0 ) - 1 );
}

bool dist_between( int min, int max )
// checks whether distance to target is within bounds
{
    return ( ( face_distance() < max ) && ( face_distance() > min ) );
}

bool z_axis_dist( int dist )
{
    return ( abs( self.z - target.z ) <= dist ) ? true : false;
}

bool same_z_axis()
// checks whether our character is on the same z axis as the opponent
{
    return ( abs( self.z - target.z ) <= 8 ) ? true : false;
}

int ego()
{
    if( ( self.frame >= 261 ) && ( self.frame <= 269 ) )
    {
        if( ( target.state == 13 ) || ( target.state == 14 ) )
        {
            D();
            return 0;
        }
        if( ( self.frame == 269 ) && ( target.y == 0 ) )
        {
            D();
            return 0;
        }
        return 1;
    }
    else
    {



        if( dist_between(15,60) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 75 ) )
        {
            DuA();
            return 0;
        }


        if( dist_between(60,80) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 75 ) )
        {
            DdA();
            A();
        }




        if( dist_between(400,1000) && same_z_axis() && ( self.mp > 130 )  && ( difficulty < 1))
        {
            if( self.facing )
            {
                DlJ();
                A();
            }
            else
            {
                DrJ();
                A();
            }
            return 0;
        }


        if( dist_between(100,210) && ( self.mp > 95 ) && ( target.state < 10 ) && same_z_axis() && ( difficulty < 1)  )
        {
            if( self.facing )
            {
                DlA();
                A();
            }
            else
            {
                DrA();
                A();
            }
            return 0;
        }





        if( dist_between(210,320) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 90) )
        {
            DuJ();
        }




        if( dist_between(-250,250) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 110 ) && ( difficulty < 2) )
        {
            DdJ();
            A();
        }



    }
    return 0;
}