int face_distance()
// distance to target, positive when faced towards it
// 80 pixels may be considered as a maximum distance allowing close combat
{
    return ( self.x - target.x ) * ( 2 * ( self.facing ? 1 : 0 ) - 1 );
}

bool dist_between( int min, int max )
// checks whether distance to target is within bounds
{
    return ( ( face_distance() < max ) && ( face_distance() > min ) );
}

bool z_axis_dist( int dist )
{
    return ( abs( self.z - target.z ) <= dist ) ? true : false;
}

bool same_z_axis()
// checks whether our character is on the same z axis as the opponent
{
    return ( abs( self.z - target.z ) <= 8 ) ? true : false;
}

int ego()
{
    if( ( self.frame >= 261 ) && ( self.frame <= 269 ) )
    {
        if( ( target.state == 13 ) || ( target.state == 14 ) )
        {
            D();
            return 0;
        }
        if( ( self.frame == 269 ) && ( target.y == 0 ) )
        {
            D();
            return 0;
        }
        return 1;
    }
    else
    {



        if( dist_between(96,120) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 60 ) )
        {
            DuA();
            A();
        }


        if( dist_between(50,105) && ( target.state < 10 ) && same_z_axis() )
        {
            DuJ();
            A(1,0);
            A(1,0);
            A(1,0);
            A(1,0);
        }

        if( dist_between(-400,200) && ( target.state < 10 ) && ( self.mp > 100 ) && same_z_axis()  )
        {
            DdJ();
            A();
        }


        if( dist_between(100,320) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 160 ) && ( difficulty < 2)  )
        {
            if( self.facing )
            {
                DlJ();
                A();
            }
            else
            {
                DrJ();
                A();
            }
            return 0;
        }



        if( dist_between(170,300) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 70 ) && ( difficulty < 1) )
        {
            if( self.facing )
            {
                DlA();
                A();
            }
            else
            {
                DrA();
                A();
            }
            return 0;
        }



        if( dist_between(85,140) && ( target.state < 14 ) && ( target.state != 10 ) && same_z_axis() )
        {
            A(1,0);
            A(1,0);
            A(1,0);
            A(1,0);
        }


        if( dist_between(-10,85) && ( (self.x % 2) == 1 ) && ( difficulty < 2))
        {
 	    J();
            left(1,1);
        }

        if( dist_between(-10,85) && ( (self.x % 2) == 0 ) && ( difficulty < 2))
        {
 	    J();
            right(1,1);
        }

        if( ( self.frame > 271 ) && ( self.frame < 280 ) )
        {
            DuA();
            A(1,0);
        }





        if (( target.frame > 235 ) && ( self.hp < 400 ) && ( self.mp > 80 ) && ( difficulty < 1) )
        {
            DJA();
            return 0;
        }

    }
    return 0;
}