int face_distance()
// distance to target, positive when faced towards it
// 80 pixels may be considered as a maximum distance allowing close combat
{
    return ( self.x - target.x ) * ( 2 * ( self.facing ? 1 : 0 ) - 1 );
}

bool dist_between( int min, int max )
// checks whether distance to target is within bounds
{
    return ( ( face_distance() < max ) && ( face_distance() > min ) );
}

bool z_axis_dist( int dist )
{
    return ( abs( self.z - target.z ) <= dist ) ? true : false;
}

bool same_z_axis()
// checks whether our character is on the same z axis as the opponent
{
    return ( abs( self.z - target.z ) <= 8 ) ? true : false;
}

int ego()
{
    if( ( self.frame >= 261 ) && ( self.frame <= 269 ) )
    {
        if( ( target.state == 13 ) || ( target.state == 14 ) )
        {
            D();
            return 0;
        }
        if( ( self.frame == 269 ) && ( target.y == 0 ) )
        {
            D();
            return 0;
        }
        return 1;
    }
    else
    {



        if( dist_between(1,70) && ( target.state < 10 ) && ( self.mp > 65 )  && same_z_axis() )
        {
            DuA();
            A();
        }

        if( dist_between(100,115) && ( target.state < 10 ) && ( self.mp > 85 ) && same_z_axis() )
        {
            DdA();
            A();
        }

        if( dist_between(300,430) && ( target.state < 10 ) && ( self.mp > 100 ) && same_z_axis() )
        {
            DuJ();
            A();
        }


        if( dist_between(220,300) && same_z_axis() && ( self.mp > 95 ) && ( difficulty < 1) )
        {
            if( self.facing )
            {
                DlJ();
                A();
            }
            else
            {
                DrJ();
                A();
            }
            return 0;
        }

        if( dist_between(205,220) && same_z_axis() && ( self.mp > 85 ) && ( target.state < 10 ) && ( difficulty < 2 ) )
        {
            if( self.facing )
            {
                DlA();
                A();
            }
            else
            {
                DrA();
                A();
            }
            return 0;
        }


        if( dist_between(600,1000) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 90 ) )
        {
            DdJ();
            A();
        }
       




    }
    return 0;
}