int face_distance()
// distance to target, positive when faced towards it
// 80 pixels may be considered as a maximum distance allowing close combat
{
    return ( self.x - target.x ) * ( 2 * ( self.facing ? 1 : 0 ) - 1 );
}

bool dist_between( int min, int max )
// checks whether distance to target is within bounds
{
    return ( ( face_distance() < max ) && ( face_distance() > min ) );
}

bool z_axis_dist( int dist )
{
    return ( abs( self.z - target.z ) <= dist ) ? true : false;
}

bool same_z_axis()
// checks whether our character is on the same z axis as the opponent
{
    return ( abs( self.z - target.z ) <= 8 ) ? true : false;
}

int ego()
{
    if( ( self.frame >= 261 ) && ( self.frame <= 269 ) )
    {
        if( ( target.state == 13 ) || ( target.state == 14 ) )
        {
            D();
            return 0;
        }
        if( ( self.frame == 269 ) && ( target.y == 0 ) )
        {
            D();
            return 0;
        }
        return 1;
    }
    else
    {



        if( dist_between(207,295) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 70 ) )
        {
            DuA();
            A();
        }

        if( dist_between(120,153) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 70 ) )
        {
            DdA();
            A();
        }

        if( dist_between(211,350) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 80 ) && ( difficulty < 2)  )
        {
            DuJ();
            A();
        }

        if( dist_between(153,265) && ( target.state < 10 ) && ( self.mp > 85 ) && same_z_axis()  )
        {
            DdJ();
            A();
        }


        if( dist_between(350,600) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 80 ) && ( difficulty < 2)  )
        {
            if( self.facing )
            {
                DlJ();
            }
            else
            {
                DrJ();
            }
            return 0;
        }



        if( dist_between(30,120) && ( target.state < 10 ) && same_z_axis() && ( self.mp > 75 ) )
        {
            if( self.facing )
            {
                DlA();
                A();
            }
            else
            {
                DrA();
                A();
            }
            return 0;
        }


        if( dist_between(-150,150) && ( ( self.frame == 239 ) || ( self.frame == 264 )  || ( self.frame == 264 ) ) )
        {
            DdJ();
        }
       
        if( ( self.frame == 74 ) || ( self.frame == 75 )  || ( self.frame == 264 ) )
        {
            DuA();
        }


    }
    return 0;
}